/*********************************************************************************************************
**				                               Small RTOS(51)
**                                   The Real-Time Kernel(For Keil c51)
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.10.5
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
** ļ: OS_CORE.C
** : 
** ա: 200291
** 衡: Small RTOS(51) Cͷļ,һЩͺ
**         ݵǰ汾һЩҪı
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** : 
** 汾  V1.00
** ա: 2002620
** 衡: Small RTOS(51)CPU޹صĺĴ
**
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
** 衡: OSTimeTickBugkeil c51в⣬ֲϵͳܳ
**         ͳһһ¸ʽ
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200299
** 衡: OSWait()BugBugOSWait()K_TMOΪʱڼ
**         
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 2002105
** 衡: ʾʼOSTaskIDOSNextTaskID
**
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021019
** 衡: ޸ĺOSIntExit()OSSched()жϹBUGû
**         ߼̫ʱϵͳ200299޶
**         Bug
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

#define  IN_OS_CORE
#include "config.h"

#if EN_OS_INT_ENTER > 0
uint8 OSIntNesting;
#endif

uint8 OSTaskID = 0;
uint8 OSNextTaskID = 0;

uint8 OSWaitTick[OS_MAX_TASKS - 1];
#if OS_MAX_TASKS < 9
uint8 OSTaskRuning = 0xff;
#else
uint16 OSTaskRuning = 0xffff;
#endif

uint8 const OSMapTbl[] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
uint8 Os_Enter_Sum = 0;


void  OSSched(void);

/*********************************************************************************************************
** : OSIntSendSignal
** : жиָź,ʹָ
** 䡡: TaskId : ID
** 䡡: 
** ȫֱ: OSTaskRuning
** ģ: 
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
**   : 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void OSIntSendSignal(uint8 TaskId)

{
    OS_ENTER_CRITICAL();
#if OS_MAX_TASKS < 9
    OSTaskRuning |= OSMapTbl[TaskId];
#else
    if (TaskId < 8)
    {
        ((uint8 *)(&OSTaskRuning))[LOW_BYTE] |= OSMapTbl[TaskId];
    }
    else
    {
        ((uint8 *)(&OSTaskRuning))[HIGH_BYTE] |= OSMapTbl[TaskId & 0x07];
    }
#endif
    OS_EXIT_CRITICAL();
}

/*********************************************************************************************************
** : OSSendSignal
** : иָź,ʹָ
** 䡡: TaskId : ID
** 䡡: 
** ȫֱ: 
** ģ: OSSched,OSIntSendSignal
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void OSSendSignal(uint8 TaskId)

{
    OSIntSendSignal(TaskId);
    OSSched();                                              //ʼл
}

/*********************************************************************************************************
** : OSClearSignal
** : ָź,ʹָ
** 䡡: TaskId : ID
** 䡡: 
** ȫֱ: OSTaskRuning
** ģ: 
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void OSClearSignal(uint8 TaskId)

{
    OS_ENTER_CRITICAL();
#if OS_MAX_TASKS < 9
    OSTaskRuning &= ~OSMapTbl[TaskId];
#else
    if (TaskId < 8)
    {
        ((uint8 *)(&OSTaskRuning))[LOW_BYTE] &= ~OSMapTbl[TaskId];
    }
    else
    {
        ((uint8 *)(&OSTaskRuning))[HIGH_BYTE] &= ~OSMapTbl[TaskId & 0x07];
    }
#endif
    OS_EXIT_CRITICAL();
}

/*********************************************************************************************************
** : OSIntExit
** : ж˳,ڴ˽жϺл
** 䡡: 
** 䡡: 
** ȫֱ: OSIntNesting,OSNextTaskID
** ģ: OSIntCtxSw
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021019
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void OSIntExit(void)

{
    uint8 temp;

    OS_ENTER_CRITICAL();

#if EN_OS_INT_ENTER > 0
    if (OSIntNesting > 0)
    {
        OSIntNesting--;
    }
    if (OSIntNesting == 0)
    {
#endif

        Os_Enter_Sum = 0;
#if OS_MAX_TASKS < 9
        temp = OSTaskRuning;
        for (OSNextTaskID = 0; OSNextTaskID < (OS_MAX_TASKS - 1); OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                break;
            }
            temp = temp >> 1;
        }
        OSIntCtxSw();
#else
        temp = OSTaskRuning % 256;
        for (OSNextTaskID = 0; OSNextTaskID < 8; OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                goto TaskSw;
            }
            temp = temp >> 1;
        }

        temp = OSTaskRuning /256 ;
        for (; OSNextTaskID < (OS_MAX_TASKS - 1); OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                break;
            }
            temp = temp >> 1;
        }
TaskSw:
        OSIntCtxSw();
#endif

#if EN_OS_INT_ENTER >0
    }
    Os_Enter_Sum = 1;
#endif
}

/*********************************************************************************************************
** : OSSched
** : жϵл
** 䡡: 
** 䡡: 
** ȫֱ: OSIntNesting,OSNextTaskID
** ģ: OS_TASK_SW
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021019
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void  OSSched(void)

{
    uint8 temp;


    OS_ENTER_CRITICAL();
#if EN_OS_INT_ENTER > 0
    if (OSIntNesting == 0)
    {
#endif

        Os_Enter_Sum = 0;

#if OS_MAX_TASKS < 9
        temp = OSTaskRuning;
        for (OSNextTaskID = 0; OSNextTaskID < (OS_MAX_TASKS - 1); OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                break;
            }
            temp = temp >> 1;
        }
        OS_TASK_SW();
#else
        temp = OSTaskRuning % 256;
        for (OSNextTaskID = 0; OSNextTaskID < 8; OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                goto TaskSw;
            }
            temp = temp >> 1;
        }

        temp = OSTaskRuning / 256 ;
        for (; OSNextTaskID < (OS_MAX_TASKS - 1); OSNextTaskID++)
        {
            if ((temp & 0x01) != 0)
            {
                break;
            }
            temp = temp >> 1;
        }
TaskSw:
        OS_TASK_SW();
#endif

#if EN_OS_INT_ENTER > 0
    }
    else
    {
        Os_Enter_Sum = 0;
        OS_EXIT_CRITICAL();
    }
#endif
}

/*********************************************************************************************************
** : OSTimeTick
** : ϵͳʱӴ,ʱ
** 䡡: 
** 䡡: 
** ȫֱ: OSWaitTick
** ģ: OSIntSendSignal
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        void  OSTimeTick(void)
{
    uint8 i;

    for (i = 0; i < (OS_MAX_TASKS - 1); i++)                 
    {
        if (OSWaitTick[i] != 0 )
        {
            OSWaitTick[i]--;
            if (OSWaitTick[i] == 0)
            {
                OSIntSendSignal(i);
            }
        }
    }
}

/*********************************************************************************************************
** : OSWait
** : ϵͳȴ,ô˺Եȴһʱź
** 䡡: typ: ȴ¼,Ŀǰȡֵ,ֵİλ
**             K_SIG: ȴź
**             K_TMO: ȴʱ
**        ticks : ȴʱʱϵͳ
** 䡡 : NOT_OK : 
**         TMO_EVENT : ʱ
**         SIG_EVENT : ź
** ȫֱ: OSWaitTick
** ģ: OSClearSignal
**
** : 
** ա: 2002620
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200294
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200299
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 2002109
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
        uint8 OSWait(uint8 typ, uint8 ticks)

{
    OSWaitTick[OSTaskID] = ticks;
    switch(typ)
    {
    case K_SIG:
        OSWaitTick[OSTaskID] = 0;
        OSClearSignal(OSTaskID);
        OSSched();
        return SIG_EVENT;
    case K_TMO:
        OS_ENTER_CRITICAL();
        while (OSWaitTick[OSTaskID] != 0)
        {
            OSClearSignal(OSTaskID);
            OSSched();
            OS_ENTER_CRITICAL();
        }
        OS_EXIT_CRITICAL();
        return TMO_EVENT;
    case (K_TMO | K_SIG):
        if (OSWaitTick[OSTaskID] == 0)
        {
            return TMO_EVENT;
        }
        OSClearSignal(OSTaskID);
        OSSched();
        if (OSWaitTick[OSTaskID] != 0)
        {
            OSWaitTick[OSTaskID] = 0;
            return SIG_EVENT;
        }
        return TMO_EVENT;
    default:
        OSWaitTick[OSTaskID] = 0;
        return NOT_OK;
    }
}
