/*********************************************************************************************************
**				                               Small RTOS(51)
**                                   The Real-Time Kernel(For Keil c51)
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.10.5
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
*** ļ: OS_Q.C
** : 
** ա: 2002620
** 衡: Small RTOS(51)Ϣд
**
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** 
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200299
** 衡: ޸OSQIntPost()Keil C51룬û⣬Ķ
**         ϰⲿִʹKeil C51ʱ֡
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021028
** 衡: ޸OSQFlush()ʹ䲻ȴУ޸OSQCreate()룬޸OSQIntPost()
**        OSQIntPost()ʱЧʸ
**
**------------------------------------------------------------------------------------------------------
** ޸:
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

#define  IN_OS_Q
#include "config.h"

#if EN_OS_Q > 0
/*********************************************************************************************************
** : OSQCreate
** : ʼϢ
** 䡡: Buf:ΪзĴ洢ռַ
**         SizeOfBuf:ΪзĴ洢ռС
** 䡡: NOT_OK:
**         OS_Q_OK:ɹ
** ȫֱ: 
** ģ: 
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021027
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

        uint8 OSQCreate(uint8 OS_Q_MEM_SEL *Buf, uint8 SizeOfBuf)
//Buf[0]:ֽ,Buf[1]:Bufܳ,Buf[2]:Զ,Buf[3](,Buf[4]):ȴб
{
    OS_ENTER_CRITICAL();

    if ((SizeOfBuf >= 5) && (Buf != NULL))
    {
        Buf[0] = 0;
        Buf[1] = SizeOfBuf;
#if OS_MAX_TASKS < 9
        Buf[2] = 4;
#else
        Buf[2] = 5;
#endif
        Buf[3] = 0;
        Buf[4] = 0;

        OS_EXIT_CRITICAL();
        return OS_Q_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return NOT_OK;
    }

}

/*********************************************************************************************************
** : OSQPend
** : ȴϢеϢ
** 䡡: Ret:صϢ
**         Buf:ָеָ
**         Tick:ȴʱ
** 䡡: NOT_OK:
**         OS_Q_OK:յϢ
**         OS_Q_TMO:ʱ
**         OS_Q_NOT_OK:Ϣ
** ȫֱ: 
** ģ: OSRunningTaskID,OSClearSignal,OSSched,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_PENT > 0

        uint8 OSQPend(uint8 idata *Ret, uint8 OS_Q_MEM_SEL *Buf, uint8 Tick)
{
#ifdef __C51__
    uint8 idata *cp;
#endif

#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    OS_ENTER_CRITICAL();

    OSWaitTick[OSRunningTaskID()] = Tick;

#ifdef __C51__
    SP++;
    *((uint8 idata * idata *)SP) = Ret;
#endif


#if OS_MAX_TASKS < 9
    Buf[3] |= OSMapTbl[OSRunningTaskID()];
#else
    if (OSRunningTaskID() < 8)
    {
        Buf[3] |= OSMapTbl[OSRunningTaskID()];
    }
    else
    {
        Buf[4] |= OSMapTbl[OSRunningTaskID() & 0x07];
    }
#endif

    while (Buf[0] == 0)
    {

#ifdef __C51__
        SP = SP + sizeof(Buf);
        *((uint8 OS_Q_MEM_SEL * idata *)(SP + 1 - sizeof(Buf))) = Buf;
#endif

        OSClearSignal(OSRunningTaskID());
        OSSched();
        OS_ENTER_CRITICAL();


#ifdef __C51__
        Buf = *((uint8 OS_Q_MEM_SEL * idata *)(SP + 1 - sizeof(Buf)));
        SP = SP - sizeof(Buf);
#endif

        if (OSWaitTick[OSRunningTaskID()] == 0)
        {
            break;
        }
    }

#if OS_MAX_TASKS < 9
    Buf[3] &= ~OSMapTbl[OSRunningTaskID()];
#else
    if (OSRunningTaskID() < 8)
    {
        Buf[3] &= ~OSMapTbl[OSRunningTaskID()];
    }
    else
    {
        Buf[4] &= ~OSMapTbl[OSRunningTaskID() & 0x07];
    }
#endif

    if (Buf[0] > 0)
    {
        Buf[0]--;
        Buf[2]++;
        if (Buf[2] >= Buf[1] )
        {
#if OS_MAX_TASKS < 9
            Buf[2] = 4;
#else
            Buf[2] = 5;
#endif
        }
#ifdef __C51__
        cp = (uint8 idata *)(*((uint8 idata *)SP));
        SP--;
        *cp = Buf[Buf[2]];
#else
        *Ret = Buf[Buf[2]];
#endif
        OS_EXIT_CRITICAL();
        return OS_Q_OK;
    }
    else
    {
#ifdef __C51__
        SP--;
#endif
        OS_EXIT_CRITICAL();
        return OS_Q_TMO;
    }
}
#endif

/*********************************************************************************************************
** : OSQAccept
** : ޵ȴϢȡϢ
** 䡡: Ret:صϢ
**         Buf:ָеָ
** 䡡: NOT_OK:
**         OS_Q_OK:յϢ
**         OS_Q_TMO:ʱ
**         OS_Q_NOT_OK:Ϣ
** ȫֱ: 
** ģ: OSClearSignal,OSSched,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_ACCEPT > 0
        uint8 OSQAccept(uint8 idata *Ret, uint8 OS_Q_MEM_SEL *Buf)
{
#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    OS_ENTER_CRITICAL();

    if (*Buf != 0)
    {
        Buf[0]--;
        Buf[2]++;
        if (Buf[2] >= Buf[1])
        {
#if OS_MAX_TASKS < 9
            Buf[2] = 4;
#else
            Buf[2] = 5;
#endif
        }
        *Ret = Buf[Buf[2]];
        OS_EXIT_CRITICAL();
        return OS_Q_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return OS_Q_NOT_OK;
    }
}
#endif


/*********************************************************************************************************
** : OSQIntPost
** : жFIFOʽϢ
** 䡡: Buf:ָеָ
**         Data:Ϣ
** 䡡: OS_Q_FULL:
**         OS_Q_OK:ͳɹ
** ȫֱ: 
** ģ: OSIntSendSignal,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 200299
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021028
**------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_INT_POST > 0  || EN_OS_Q_POST > 0
        uint8 OSQIntPost(uint8 OS_Q_MEM_SEL *Buf, uint8 Data)
{
    uint8 temp,i;

#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    OS_ENTER_CRITICAL();

#if OS_MAX_TASKS < 9
    if (Buf[0] < (Buf[1]-4))
#else
    if (Buf[0] < (Buf[1]-5))
#endif
    {
#ifdef __C51__
        SP++;
        *((uint8 idata *)SP) = Data;
#endif
        temp = Buf[2] + Buf[0] + 1;
        if (temp >= Buf[1])
        {
#if OS_MAX_TASKS < 9
            temp = temp - Buf[1]+4;
#else
            temp = temp - Buf[1]+5;
#endif
        }
#ifdef __C51__
        Buf[temp] = *((uint8 idata *)SP);
        SP--;
#else
        Buf[temp] = Data;
#endif

        Buf[0]++;
        if (Buf[0] == 1)
        {
            temp = Buf[3];
#if OS_MAX_TASKS < 9
            for (i = 0; i < OS_MAX_TASKS; i++)
            {
                if ((temp & 0x01) != 0)
                {
                    break;
                }
                temp = temp >> 1;
            }
            if (i < OS_MAX_TASKS )
            {
                Buf[3] &= ~OSMapTbl[i];
                OSIntSendSignal(i);
            }
#else
            for (i = 0; i < 8; i++)
            {
                if ((temp & 0x01) != 0)
                {
                    break;
                }
                temp = temp >> 1;
            }
            if (i >= 8 )
            {
                temp = Buf[4];
                for (; i < OS_MAX_TASKS; i++)
                {
                    if ((temp & 0x01) != 0)
                    {
                        break;
                    }
                    temp = temp >> 1;
                }
            }
            if (i < OS_MAX_TASKS )
            {
                if (i < 8)
                {
                    Buf[3] &= ~OSMapTbl[i];
                }
                else
                {
                    Buf[4] &= ~OSMapTbl[i & 0x07];
                }
                OSIntSendSignal(i);
            }
#endif
        }
        OS_EXIT_CRITICAL();
        return OS_Q_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return OS_Q_FULL;
    }
}
#endif

/*********************************************************************************************************
** : OSQIntPostFront
** : жLIFOʽϢ
** 䡡: Buf:ָеָ
**         Data:Ϣ
** 䡡: OS_Q_FULL:
**         OS_Q_OK:ͳɹ
** ȫֱ: 
** ģ: OSIntSendSignal,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_INT_POST_FRONT > 0 || EN_OS_Q_POST_FRONT > 0
        uint8 OSQIntPostFront(uint8 OS_Q_MEM_SEL *Buf, uint8 Data)
{
    uint8 temp,i;

#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    OS_ENTER_CRITICAL();

#if OS_MAX_TASKS < 9
    if (Buf[0] < (Buf[1]-4))
#else
    if (Buf[0] < (Buf[1]-5))
#endif
    {
        Buf[Buf[2]] = Data;
        Buf[0]++;
        Buf[2]--;
#if OS_MAX_TASKS < 9
        if (Buf[2] < 4)
#else
        if (Buf[2] < 5)
#endif
        {
            Buf[2] = Buf[1]-1;
        }
        if (Buf[0] == 1)
        {
            temp = Buf[3];
#if OS_MAX_TASKS < 9
            for (i = 0; i < OS_MAX_TASKS; i++)
            {
                if ((temp & 0x01) != 0)
                {
                    break;
                }
                temp = temp >> 1;
            }
            if (i < OS_MAX_TASKS )
            {
                Buf[3] &= ~OSMapTbl[i];
                OSIntSendSignal(i);
            }
#else
            for (i = 0; i < 8; i++)
            {
                if ((temp & 0x01) != 0)
                {
                    break;
                }
                temp = temp >> 1;
            }
            if (i >= 8 )
            {
                temp = Buf[4];
                for (; i < OS_MAX_TASKS; i++)
                {
                    if ((temp & 0x01) != 0)
                    {
                        break;
                    }
                    temp = temp >> 1;
                }
            }
            if (i < OS_MAX_TASKS )
            {
                if (i < 8)
                {
                    Buf[3] &= ~OSMapTbl[i];
                }
                else
                {
                    Buf[4] &= ~OSMapTbl[i & 0x07];
                }
                OSIntSendSignal(i);
            }
#endif
        }
        OS_EXIT_CRITICAL();
        return OS_Q_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return OS_Q_FULL;
    }
}
#endif

/*********************************************************************************************************
** : OSQPost
** : FIFOʽϢ
** 䡡: Buf:ָеָ
**         Data:Ϣ
** 䡡: OS_Q_FULL:
**         OS_Q_OK:ͳɹ
** ȫֱ: 
** ģ: OSQIntPost,OSSched
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_POST > 0
        uint8 OSQPost(uint8 OS_Q_MEM_SEL *Buf, uint8 Data)
{
#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    if (OSQIntPost(Buf,Data) == OS_Q_OK)
    {
        OSSched();
        return OS_Q_OK;
    }
    else
    {
        return OS_Q_FULL;
    }
}
#endif

/*********************************************************************************************************
** : OSQPostFront
** : LIFOʽϢ
** 䡡: Buf:ָеָ
**         Data:Ϣ
** 䡡: OS_Q_FULL:
**         OS_Q_OK:ͳɹ
** ȫֱ: 
** ģ: OSQIntPostFront,OSSched
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_POST_FRONT > 0
        uint8 OSQPostFront(uint8 OS_Q_MEM_SEL *Buf, uint8 Data)
{
#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return NOT_OK;
    }
#endif

    if (OSQIntPostFront(Buf,Data) == OS_Q_OK)
    {
        OSSched();
        return OS_Q_OK;
    }
    else
    {
        return OS_Q_FULL;
    }
}
#endif

/*********************************************************************************************************
** : OSQNMsgs
** : ȡϢϢ
** 䡡: Buf:ָеָ
** 䡡: Ϣ
** ȫֱ: 
** ģ: OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_NMsgs > 0
        uint8 OSQNMsgs(uint8 OS_Q_MEM_SEL *Buf)
{
    uint8 temp;

#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return 0;
    }
#endif

    OS_ENTER_CRITICAL();
    temp = Buf[0];
    OS_EXIT_CRITICAL();
    return temp;
}
#endif

/*********************************************************************************************************
** : OSQSize
** : ȡϢ
** 䡡: Buf:ָеָ
** 䡡: Ϣ
** ȫֱ: 
** ģ: OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_SIZE > 0
        uint8 OSQSize(uint8 OS_Q_MEM_SEL *Buf)
{
    uint8 temp;

#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return 0;
    }
#endif

    OS_ENTER_CRITICAL();
#if OS_MAX_TASKS < 9
    temp = Buf[1] - 4;
#else
    temp = Buf[1] - 5;
#endif
    OS_EXIT_CRITICAL();
    return temp;
}
#endif

/*********************************************************************************************************
** : OSQFlush
** : ն
** 䡡: Buf:ָеָ
** 䡡: 
** ȫֱ: 
** ģ: OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021026
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_Q_FLUSH > 0
        void OSQFlush (uint8 OS_Q_MEM_SEL *Buf)
{
#if EN_OS_Q_CHK > 0
    if (Buf == NULL)
    {
        return;
    }
#endif

    Buf[0] = 0;
#if OS_MAX_TASKS < 9
    Buf[2] = 4;
#else
    Buf[2] = 5;
#endif
}
#endif

#endif
