/*********************************************************************************************************
**				                               Small RTOS(51)
**                                   The Real-Time Kernel(For Keil c51)
**
**                                  (c) Copyright 2002-2002, chenmingji
**                                           All Rights Reserved
**
**                                                  V1.10
**
**
**--------------ǰ汾Ϣ----------------------------------------------------------------------------
** ļ: OS_Q.C
** : 
** ա: 200291
** 衡: Small RTOS(51)ź
**
**--------------ʷ汾Ϣ----------------------------------------------------------------------------
** 
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021020
** 衡: ͳһʽ
**
**------------------------------------------------------------------------------------------------------
** ޸: 
** ա: 20021026
** 衡: źĴ󣬸OSSemIntPost()ִܣ
**         OSSemAccept()źЧʱBugOSSemQuery()жӳ
**         Ӱ죬OSSemPend()ڳʱʱBug
**
**------------------------------------------------------------------------------------------------------
** ޸:
** ա:
** 衡:
**
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

#define  IN_OS_SEM
#include "config.h"

#if EN_OS_SEM > 0
#if OS_MAX_TASKS < 9
uint8 OS_SEM_MEM_SEL OsSemBuf[OS_MAX_SEMS * 2];
#else
uint8 OS_SEM_MEM_SEL OsSemBuf[OS_MAX_SEMS * 3];
#endif



/*********************************************************************************************************
** : OSSemCreate
** : ʼϢ
** 䡡: Index:ź
**         data:źʼֵ
** 䡡: NOT_OK:ûź
**         OS_SEM_OK:ɹ
** ȫֱ: 
** ģ: 
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

        uint8 OSSemCreate(uint8 Index,uint8 Data)
{
    OS_ENTER_CRITICAL();
    if (Index < OS_MAX_SEMS )
    {
#if OS_MAX_TASKS < 9
        OsSemBuf[2 * Index] = Data;
        OsSemBuf[2 * Index + 1] = 0;
#else
        OsSemBuf[3 * Index] = Data;
        OsSemBuf[3 * Index + 1] = 0;
        OsSemBuf[3 * Index + 2] = 0;
#endif
        OS_EXIT_CRITICAL();
        return OS_SEM_OK;
    }
    OS_EXIT_CRITICAL();
    return NOT_OK;
}

/*********************************************************************************************************
** : OSSemPend
** : ȴһź
** 䡡: Index:ź
**         Tick:ȴʱ
** 䡡: NOT_OK:
**         OS_SEM_OK:õź
**         OS_SEM_TMO:ʱ
**         OS_SEM_NOT_OK:ûеõź
** ȫֱ: 
** ģ: OSRunningTaskID,OSClearSignal,OSSched,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021020
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021027
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_SEM_PENT > 0

        uint8 OSSemPend(uint8 Index, uint8 Tick)
{
#if EN_OS_SEM_CHK > 0
    if (Index >= OS_MAX_SEMS)
    {
        return 0;
    }
#endif

    OS_ENTER_CRITICAL();

    OSWaitTick[OSRunningTaskID()] = Tick;

#if OS_MAX_TASKS < 9
    OsSemBuf[Index * 2 + 1] |= OSMapTbl[OSRunningTaskID()];
#else
    if (OSRunningTaskID() < 8)
    {
        OsSemBuf[Index * 3 + 1] |= OSMapTbl[OSRunningTaskID()];
    }
    else
    {
        OsSemBuf[Index * 3 + 2] |= OSMapTbl[OSRunningTaskID() & 0x07];
    }
#endif

#if OS_MAX_TASKS < 9
    while (OsSemBuf[Index * 2] == 0)
    {
#else
    while (OsSemBuf[Index * 3] == 0)
    {
#endif

#ifdef __C51__
        SP++;
        *((uint8 idata *)SP) = Index;
#endif
        OSClearSignal(OSRunningTaskID());
        OSSched();
        OS_ENTER_CRITICAL();
#ifdef __C51__
        Index = *((uint8 idata *)SP);
        SP--;
#endif
        if (OSWaitTick[OSRunningTaskID()] == 0)
        {
            break;
        }
    }

#if OS_MAX_TASKS < 9
    OsSemBuf[Index * 2 + 1] &= ~OSMapTbl[OSRunningTaskID()];
#else
    if (OSRunningTaskID() < 8)
    {
        OsSemBuf[Index * 3 + 1] &= ~OSMapTbl[OSRunningTaskID()];
    }
    else
    {
        OsSemBuf[Index * 3 + 2] &= ~OSMapTbl[OSRunningTaskID() & 0x07];
    }
#endif

#if OS_MAX_TASKS < 9
    if (OsSemBuf[Index * 2] > 0)
    {
        OsSemBuf[Index * 2]--;
#else
    if (OsSemBuf[Index * 3] > 0)
    {
        OsSemBuf[Index * 3]--;
#endif
        OS_EXIT_CRITICAL();
        return OS_SEM_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return OS_SEM_TMO;
    }
}
#endif

/*********************************************************************************************************
** : OSSemAccept
** : ޵ȴź
** 䡡: Index:ź
** 䡡: NOT_OK:
**         OS_SEM_OK:õź
**         OS_SEM_TMO:ʱ
**         OS_SEM_NOT_OK:ûеõź
** ȫֱ: 
** ģ: OSClearSignal,OSSched,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021020
***-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021026
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_SEM_ACCEPT > 0
        uint8 OSSemAccept(uint8 Index)
{
#if EN_OS_SEM_CHK > 0
    if (Index >= OS_MAX_SEMS)
    {
        return 0;
    }
#endif

    OS_ENTER_CRITICAL();

#if OS_MAX_TASKS < 9
    if (OsSemBuf[Index * 2] > 0)
    {
        OsSemBuf[Index * 2]--;
#else
    if (OsSemBuf[Index * 3] > 0)
    {
        OsSemBuf[Index * 3]--;
#endif
        OS_EXIT_CRITICAL();
        return OS_SEM_OK;
    }
    else
    {
        OS_EXIT_CRITICAL();
        return OS_SEM_NOT_OK;
    }
}
#endif


/*********************************************************************************************************
** : OSSemIntPost
** : жзһź
** 䡡: Index:ź
** 䡡: NOT_OK:
**         OS_SEM_OK:ͳɹ
** ȫֱ: 
** ģ: OSIntSendSignal,OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021026
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_SEM_INT_POST > 0  || EN_OS_SEM_POST > 0
        uint8 OSSemIntPost(uint8 Index)
{
    uint8 temp,i;

#if EN_OS_SEM_CHK > 0
    if (Index >= OS_MAX_SEMS)
    {
        return NOT_OK;
    }
#endif

    OS_ENTER_CRITICAL();

#if OS_MAX_TASKS < 9
    if (OsSemBuf[Index * 2] <255)
    {
        OsSemBuf[Index * 2]++;
    }

    temp = OsSemBuf[Index*2+1];
    for (i = 0; i < OS_MAX_TASKS -1; i++)
    {
        if ((temp & 0x01) != 0)
        {
            break;
        }
        temp = temp >> 1;
    }
    if (i < OS_MAX_TASKS)
    {
        OsSemBuf[Index * 2 + 1] &= ~OSMapTbl[i];
        OSIntSendSignal(i);
    }
#else
    if (OsSemBuf[Index * 3] <255)
    {
        OsSemBuf[Index * 3]++;
    }

    temp = OsSemBuf[Index * 3 + 1];
    for (i = 0; i < 8; i++)
    {
        if ((temp & 0x01) != 0)
        {
            break;
        }
        temp = temp >> 1;
    }
    if (i >= 8)
    {
        temp = OsSemBuf[Index * 3 + 2];
        for ( ; i < (OS_MAX_TASKS - 1); i++)
        {
            if ((temp & 0x01) != 0)
            {
                break;
            }
            temp = temp >> 1;
        }
    }
    if (i < OS_MAX_TASKS)
    {
        if (i < 8)
        {
            OsSemBuf[Index * 3 + 1] &= ~OSMapTbl[i];
        }
        else
        {
            OsSemBuf[Index * 3 + 2] &= ~OSMapTbl[i & 0x07];
        }
        OSIntSendSignal(i);
    }
#endif
    OS_EXIT_CRITICAL();
    return OS_SEM_OK;
}
#endif

/*********************************************************************************************************
** : OSSemPost
** : һź
** 䡡: Index:ź
** 䡡: NOT_OK:
**         OS_SEM_OK:ͳɹ
** ȫֱ: 
** ģ: OSSemIntPost,OSSched
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_SEM_POST > 0
        uint8 OSSemPost(uint8 Index)
{
    if (OSSemIntPost(Index) == OS_SEM_OK)
    {
        OSSched();
        return OS_SEM_OK;
    }
    else
    {
        return NOT_OK;
    }
}
#endif

/*********************************************************************************************************
** : OSSemQuery
** : ѯź
** 䡡: Index:ź
** 䡡: źֵ
** ȫֱ: 
** ģ: OS_ENTER_CRITICAL,OS_EXIT_CRITICAL
**
** : 
** ա: 200291
**-------------------------------------------------------------------------------------------------------
** ޡ: 
** ա: 20021026
**-------------------------------------------------------------------------------------------------------
** ޡ:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
#if EN_OS_SEM_QUERY > 0
        uint8 OSSemQuery(uint8 Index)
{
    if (Index >= OS_MAX_SEMS)
    {
        return 0;
    }

#if OS_MAX_TASKS < 9
        return OsSemBuf[2*Index];
#else
        return OsSemBuf[3*Index];
#endif
    return temp;
}
#endif



#endif
